package chapter8;

import java.io.File;
import java.util.Scanner;

public class ClosestPoints {

    /**
     * Read 1000 points from points.txt. 
     */
    public static double[][] readPoints() {
        double A[][] = new double[1000][2];
        Scanner input = null;
        try {
            input = new Scanner(new File("points.txt"));
        } catch (Exception ex) {
            System.out.println("Could not open file.");
            System.exit(1);
        }

        for (int p = 0; p < 1000; p++) {
            A[p][0] = input.nextDouble();
            A[p][1] = input.nextDouble();
        }

        return A;
    }

    /**
     * Compute the distance between two points (x1, y1) and (x2, y2)
     */
    public static double distance(
            double x1, double y1, double x2, double y2) {
        return Math.sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
    }

    public static void main(String[] args) {
        double points[][] = readPoints();

        // p1 and p2 are the indices in the points array
        int p1 = 0, p2 = 1; // Initial two points
        double shortestDistance = distance(points[p1][0], points[p1][1],
                points[p2][0], points[p2][1]); // Initialize shortestDistance

        // Compute distance for every two points
        for (int i = 0; i < points.length; i++) {
            for (int j = i + 1; j < points.length; j++) {
                double distance = distance(points[i][0], points[i][1],
                        points[j][0], points[j][1]); // Find distance

                if (shortestDistance > distance) {
                    p1 = i; // Update p1
                    p2 = j; // Update p2
                    shortestDistance = distance; // Update shortestDistance 
                }
            }
        }

        // Display result
        System.out.println("The closest two points are "
                + "(" + points[p1][0] + ", " + points[p1][1] + ") and ("
                + points[p2][0] + ", " + points[p2][1] + ")");
    }

}
